require 'sinatra'
require_relative 'handler'

module Api
  class Web < Sinatra::Base


    post '/apps/connect' do
      if connect(params)[:code] == 200
        status 200
        body ['Successfully logged!']
      else
        status 400
        body ['Sorry, an error occured']
      end
    end
    after do
      response
    end

    private ################

    def format_option(params)
      option = {}
      option = {user: true, app: false} if (params[:option][:user] == 'true')
      option = {user: false, app: true} if (params[:option][:app] == 'true')
      option
    end

    def connect(params)
      Api::Handler.connect(params[:object].to_json, format_option(params))
    end
  end
end
